#if !defined(__SHAPEOBJECT_H)
#define __SHAPEOBJECT_H

#define LINE 0
#define RECTANGLE 1
#define ELLIPSE 2

class CShapeObject : public CObject
{
protected:
	unsigned int m_nShapeMode;				//  (shape) (type)
	COLORREF m_Color;
	int m_nThickness;
	CPoint m_ptStart;
	CPoint m_ptEnd;
	CShapeObject();					// Default constructor - should not be used

public:
	virtual ~CShapeObject();
	virtual void Draw(CDC* pDC, CShapeObject* pObj=0) {}
};

class CLineObject : public CShapeObject
{
protected:
	CLineObject();					// Default constructor - should not be used

public:
	CLineObject(CPoint ptStart, CPoint ptEnd, COLORREF aColor, int aThick);
	~CLineObject();
	virtual void Draw(CDC* pDC, CShapeObject* pObj=0);
};


class CRectangleObject : public CShapeObject
{
protected:
	CRectangleObject();					// Default constructor - should not be used

public:
	CRectangleObject(CPoint ptStart, CPoint ptEnd, COLORREF aColor, int aThick);
	~CRectangleObject();
	virtual void Draw(CDC* pDC, CShapeObject* pObj=0);
};

class CEllipseObject : public CShapeObject
{
protected:
	CEllipseObject();					// Default constructor - should not be used

public:
	CEllipseObject(CPoint ptStart, CPoint ptEnd, COLORREF aColor, int aThick);
	~CEllipseObject();
	virtual void Draw(CDC* pDC, CShapeObject* pObj=0);
};

#endif