// SimpleShapeDrawingDoc.h : interface of the CSimpleShapeDrawingDoc class
//


#pragma once
#include "ShapeObject.h"

class CSimpleShapeDrawingDoc : public CDocument
{
protected: // create from serialization only
	CSimpleShapeDrawingDoc();
	DECLARE_DYNCREATE(CSimpleShapeDrawingDoc)

// Attributes
public:

// Operations
public:
	POSITION GetListHeadPosition() { return m_ShapeObjectList.GetHeadPosition(); }		// Return list head POSITION value
	CShapeObject* GetNext(POSITION& aPos) { return m_ShapeObjectList.GetNext(aPos); }	// Return current object pointer
	void AddShapeObject(CShapeObject* pObj);			// Add an object to the list     
	void DeleteShapeObject(CShapeObject* pObj);			// Delete an object in the list
	//unsigned int GetShapeObjectType();					// Get the object type
	//COLORREF GetShapeObjectColor();						// Get the object color
	//int GetShapeObjectThickness();						// Get the object thickness

// Overrides
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);

// Implementation
public:
	virtual ~CSimpleShapeDrawingDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Attributes
protected:
	unsigned int m_nShapeMode;				//  (shape) (type)
	COLORREF m_Color;					//  (shape) (color)
	int m_nThickness;					//  (shape) β(thickness)
	CTypedPtrList<CObList, CShapeObject*> m_ShapeObjectList;  //   ϴ Ʈ

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};
