// SimpleShapeDrawingView.cpp : implementation of the CSimpleShapeDrawingView class
//

#include "stdafx.h"
#include "SimpleShapeDrawing.h"

#include "SimpleShapeDrawingDoc.h"
#include "SimpleShapeDrawingView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSimpleShapeDrawingView

IMPLEMENT_DYNCREATE(CSimpleShapeDrawingView, CView)

BEGIN_MESSAGE_MAP(CSimpleShapeDrawingView, CView)
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, &CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, &CView::OnFilePrintPreview)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
END_MESSAGE_MAP()

// CSimpleShapeDrawingView construction/destruction

CSimpleShapeDrawingView::CSimpleShapeDrawingView()
{
	// TODO: add construction code here
	m_ptStart = CPoint(0, 0);
	m_ptEnd = CPoint(0, 0); 
	m_aShapeObject = NULL;
	m_bDrawMode = FALSE;
}

CSimpleShapeDrawingView::~CSimpleShapeDrawingView()
{
}

BOOL CSimpleShapeDrawingView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

// CSimpleShapeDrawingView drawing

void CSimpleShapeDrawingView::OnDraw(CDC* pDC)
{
	CSimpleShapeDrawingDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if (!pDoc)
		return;

	// TODO: add draw code for native data here

	// ťƮ  ü Ʈ 鼭,   ׸.
	POSITION aPos = pDoc->GetListHeadPosition();
	CShapeObject* pObj = 0;				// Store for a shape object pointer
	while (aPos) {						// Loop while aPos is not null
		pObj = pDoc->GetNext(aPos);		// Get the current shape object pointer
		pObj->Draw(pDC);
	}
}


// CSimpleShapeDrawingView printing

BOOL CSimpleShapeDrawingView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSimpleShapeDrawingView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSimpleShapeDrawingView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}


// CSimpleShapeDrawingView diagnostics

#ifdef _DEBUG
void CSimpleShapeDrawingView::AssertValid() const
{
	CView::AssertValid();
}

void CSimpleShapeDrawingView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CSimpleShapeDrawingDoc* CSimpleShapeDrawingView::GetDocument() const // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSimpleShapeDrawingDoc)));
	return (CSimpleShapeDrawingDoc*)m_pDocument;
}
#endif //_DEBUG


// CSimpleShapeDrawingView message handlers

void CSimpleShapeDrawingView::OnLButtonDown(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	// MFC Լ ̿Ͽ 콺 ĸó Ѵ.
	SetCapture();

	// ׸ 忡 Ѵ.
	m_bDrawMode = TRUE;

	// 콺 Ŀ ǥ Ѵ.
	m_ptStart = m_ptEnd = point; 

	CView::OnLButtonDown(nFlags, point);
}

void CSimpleShapeDrawingView::OnLButtonUp(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	// ׸ 带 Ѵ.
	m_bDrawMode = FALSE;

	// 콺 ĸĸ Ѵ.
	if (this == GetCapture())
		ReleaseCapture();                

	//   , ťƮ ߰Ѵ.
	if (m_aShapeObject) {
		GetDocument()->AddShapeObject(m_aShapeObject);
		GetDocument()->UpdateAllViews(0,0,m_aShapeObject);  // Tell all the views
		m_aShapeObject = NULL;              // Reset the shape object pointer
	}

	CView::OnLButtonUp(nFlags, point);
}

void CSimpleShapeDrawingView::OnMouseMove(UINT nFlags, CPoint point)
{
	// TODO: Add your message handler code here and/or call default

	// ׸ ̸   ׸⸦ ݺѴ.
	if (m_bDrawMode) { 

		CClientDC dc(this);                // DC is for this view
		
		dc.SetROP2(R2_NOTXORPEN);          // Set the drawing mode
		if ((nFlags & MK_LBUTTON)  && (this == GetCapture())) {

			//   ǥ Ѵ.
			m_ptEnd = point; 

			//    ׸ ѹ  ׷ Ⱥ̰ϰ, ShapeObject ش.
			if (m_aShapeObject) {
				dc.SetROP2(R2_NOTXORPEN);	// Set drawing mode
				m_aShapeObject->Draw(&dc);	// Redraw the old shape object so it disappears from the view
				delete m_aShapeObject;		// Delete the old shape object
				m_aShapeObject = NULL;		// Reset the shape object pointer to NULL
			}

			// ťƮ  Ӽ ӽ ShapeObject ϰ, ׷ش
			m_aShapeObject = new CLineObject(m_ptStart, m_ptEnd, RGB(255, 0, 0), 1);	// Create a new shape object
			m_aShapeObject->Draw(&dc);					// Draw the shape object
		}
	}
	
	CView::OnMouseMove(nFlags, point);
}
